$regfile = "m8def.dat"
$crystal = 12000000

Dim A As Byte , Result As Long , Zaehler As Long
Dim Temp1 As Word , Temp2 As Word , Temp3 As Word , M As Word
Dim Ref As Single , Volt As Single , D As Single , E As Single
Dim N1 As Byte , N2 As Byte , Ll1 As Byte
Dim I3 As Single , U5 As Single , R5 As Single , U6 As Single

Config Adc = Single , Prescaler = Auto
Config Timer0 = Counter , Edge = Falling
Config Timer1 = Timer , Prescale = 256

Config Pind.4 = Input                                       'PD4 ist counterinput T0
Config Portb.0 = Output                                     'Steuerausgang fr FRange
Config Portb.1 = Output                                     'Steuerausgang fr SRange
Config Portb.2 = Output                                     'Relais zur Messumschaltung Spannung I / II
Config Portd.2 = Output                                     'Steuerausgang fr Frequenz grob UP
Config Portd.5 = Output                                     'Steuerausgang fr Frequenz fein UP
Config Portd.6 = Output                                     'Steuerausgang fr Frequenz fein Down
Config Portd.7 = Output                                     'Steuerausgang fr Frequenz grob DOWN
Config Portc.5 = Output                                     'Relais Aktiv / Passiv
Config Portd.3 = Output                                     'Relais Frequenz intern / extern messen
Config Portc.4 = Output                                     'Relais Temperaturabschaltung

On Timer0 Sprung_in_sup
On Timer1 Timer_irq


Enable Timer0
Enable Timer1
Enable Interrupts

Load Timer1 , 62750

Portd.5 = 1
Portd.6 = 1
Portd.2 = 1
Portd.7 = 1
Portb.0 = 1
Portb.1 = 1
Portc.4 = 0
Do
   A = Inkey()
    If A > 0 Then
      Select Case A
        Case 49                                             'Relais Spannung
          Portb.2 = 1
        Case 50
          Portb.2 = 0
        Case 51
          Portb.0 = 0
          Waitms 10
          Portb.0 = 1
        Case 52
          Portb.1 = 0
          Waitms 10
          Portb.1 = 1
        Case 53
          Portd.2 = 0
          Waitms 10
          Portd.2 = 1
        Case 54
          Portd.5 = 0
          Waitms 10
          Portd.5 = 1
        Case 55
          Portd.6 = 0
          Waitms 10
          Portd.6 = 1
        Case 56
          Portd.7 = 0
          Waitms 10
          Portd.7 = 1
        Case 57
          Portc.5 = 0
        Case 60
          Portc.5 = 1
        Case 58
          Portd.3 = 0
        Case 59
          Portd.3 = 1
        Case 90
'***************************************PRINT***********************************
            Print ""
            Print "Spannung:" ; Fusing(volt , "##.##") ; " Volt"
            Print ""
            Print "Frequenz:" ; Result ; " Hz"
      End Select
    End If
'**************************************ADC Werte bergeben**********************
  Start Adc
      M = Getadc(0)
  Temp1 = Getadc(3)
  Temp2 = Getadc(2)
  Temp3 = Getadc(1)
  Stop Adc
''*************************************Rechenvariablen***************************
  D = 2.83 / 1023
  E = 11.82                                                 'Spannungsteiler (R1+R2)/R1
'*************************************Spannung berechnen************************
  Volt = M * D
  Volt = Volt * E
'*************************************Temperaturschalter 1**********************
  If Temp1 < 500 Then
    N1 = 1
  Else
    N1 = 0
  End If
'*************************************Temperaturschalter 1**********************
  If Temp2 < 500 Then
    N2 = 1
  Else
    N2 = 0
  End If
'**************************************Trafo R berechnen************************
  U6 = Temp3 * D
  U5 = 2.83 - U6
  I3 = U5 / 10000
  R5 = U6 / I3
  Ll1 = R5 / 100
  Ll1 = Ll1 - 16
'*********************************Temperaturprfung*****************************
  If Ll1 > 15 Or N2 = 0 Or N1 = 0 Then
    Print "Temperaturabschaltung"
    Wait 5
    Portc.4 = 1
  Else
    Portc.4 = 0
  End If
Loop
'**************************************Timer1 F Messung*************************
Sprung_in_sup:
Incr Zaehler
Return
'**************************************Timer2 F Messung*************************
Timer_irq:
Load Timer1 , 62750
 Zaehler = Zaehler * &HFF
 Zaehler = Timer0 + Zaehler
   Result = Zaehler
    Timer0 = 0
    Zaehler = 0
Return
End
'*****************************************ENDE**********************************